/*
 * macros.h        ZeroTao Macros
 *
 * Copyright (C) 2000-2002, Jason L. Shiffer <jshiffer@zerotao.com>.  All Rights Reserved.
 * See file COPYING for details.
 *
 * $Id: macros.h,v 1.2 2003/06/09 13:42:13 jshiffer Exp $
 */

/*
 * Description: 
 */

#ifndef _ZT_MACROS_H_
#define _ZT_MACROS_H_

#ifdef __cplusplus
extern "C" {
#pragma }
#endif

/* Get the absolute value of a int */
#undef ABS
#define ABS(a)  (((a) < 0) ? -(a) : (a))

/* Force a value to within a min and max */
#undef CLAMP
#define CLAMP(x, low, high)  (((x) > (high)) ? (high) : (((x) < (low)) ? (low) : (x)))

#undef CEILING
#define CEILING(x, ceil) (((x) > (ceil)) ? (ceil) : (x))

#undef FLOOR
#define FLOOR(x, floor) (((x) < (floor)) ? (floor) : (x))

/* Max of a and b */
#undef MAX
#define MAX(a, b) (((a) > (b)) ? (a) : (b))

/* Minimum of a and b */
#undef MIN
#define MIN(a, b) (((a) < (b)) ? (a) : (b))

/* Get the size of an array */
#define sizeof_array(a) (sizeof(a) / sizeof(a[0]))

/* Get the end of an array */
#define endof_array(a) ((a) + sizeof_array(a))

#ifdef __cplusplus
}
#endif

#endif /*_ZT_MACROS_H_*/
